CC = gcc
STRIP = strip
CFLAGS = -Wall -ansi -pedantic -funroll-loops -pipe -fomit-frame-pointer -O3 -mtune=pentium4 -march=i686 -DPACKAGE_NAME=\"yass\" -DPACKAGE_VERSION=\"1.11\" -DBIPROC
LDFLAGS = -static 

SOURCES = align.c assemble.c avl.c display.c global_var.c hash.c \
          kword.c list.c main.c prdyn.c proba.c red_black.c      \
          regroup.c threads.c tuple.c util.c

OBJECTS =  align.o assemble.o avl.o display.o global_var.o hash.o \
           kword.o list.o main.o prdyn.o proba.o red_black.o      \
           regroup.o threads.o tuple.o util.o

all : clean yass-Linux-i686-thread.bin

yass-Linux-i686-thread.bin : $(OBJECTS)
	$(CC) $(LDFLAGS) $(OBJECTS) /usr/lib/libm.a /usr/lib/libpthread.a -o $@
	${STRIP} $@

clean :
	rm -rf *.o yass-Linux-i686-thread.bin
