CC = gcc
STRIP = strip
CFLAGS = -Wall -ansi -pedantic -funroll-loops -pipe -fomit-frame-pointer -O3 -DPACKAGE_NAME=\"yass\" -DPACKAGE_VERSION=\"1.11\" -DBIPROC
ARCH_INTEL = -arch i686 -mtune=pentium4
ARCH_PPC   = -arch ppc  -mtune=G5
LDFLAGS    = -lm

SOURCES = align.c assemble.c avl.c display.c global_var.c hash.c \
          kword.c list.c main.c prdyn.c proba.c red_black.c      \
          regroup.c threads.c tuple.c util.c

all : clean yass-MacOSX-thread.bin

yass-MacOSX-thread.bin : yass-MacOSX-thread.intel.bin  yass-MacOSX-thread.ppc.bin 
	lipo $? -create -output $@
	${STRIP} $@

yass-MacOSX-thread.intel.bin :  $(SOURCES)
	$(CC) $(ARCH_INTEL) $(CFLAGS) $(LDFLAGS) $? -o $@
	${STRIP} $@

yass-MacOSX-thread.ppc.bin :  $(SOURCES)
	$(CC) $(ARCH_PPC) $(CFLAGS) $(LDFLAGS) $? -o $@
	${STRIP} $@

clean :
	rm -rf *.o yass-MacOSX-thread.bin yass-MacOSX-thread.intel.bin yass-MacOSX-thread.ppc.bin 
