/*
 *  YASS 1.11
 *  Copyright (C) 2004-2007
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, 
 *  Christophe Valmir, Steven Corroy
 *
 *  noe|<A>|lifl.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __DISPLAY_H_
#define __DISPLAY_H_

#include "global_var.h"
#include "tuple.h"
#include "threads.h"

void Display_Alignements(MA * first_MA,
			 int querysize,
			 char *dataquery,
			 char *dataqueryrev, char *queryname,
			 char *datatext,
			 int nbchunks, char **chunkname, int *chunksize,
			 int *chunkstart);
void Display_Stats(Feature * feature/* feature[2] */);
void Display_Params();
void Display_Progress(unsigned int pos, unsigned int maxpos,Feature  *feature);
void DisplayHistoScore(Feature * feature /* feature[2] */);
void DisplaySubstitutionMatrix();
#endif
